module testtwofish;

import dtwofish;
import std.file;
import std.md5;
import std.string;
import std.random;
import std.stdio;

void main(string[] args) {
    if (args.length == 2) {
        auto infile = args[1];
        write("Encryption mode? (type 'n' to decryption mode) [y/n]: ");
        auto enc = stdin.readln()[0] == 'y';
        auto outfile = args[1]~((enc)?".enc":".dec");
        auto keyfile = args[1]~".key";

        writeln("Making encryption key");
        write("Please type seed-word: ");
        auto seedword = stdin.readln()[0 .. $-1];
        ubyte[16] seed128;
        std.md5.sum(seed128, seedword);
        uint[8] key;
        foreach (i, ref k; key) {
            k = (cast(uint*)seed128.ptr)[i%4];
        }
            
        auto tf = new Twofish;
        tf.setKey(key);
        if (enc) {
            auto ct = tf.encrypt(cast(ubyte[])std.file.read(infile));
            std.file.write(outfile, ct);
            std.file.write(keyfile,
                           format("[%08x, %08x, %08x, %08x," ~
                                  " %08x, %08x, %08x, %08x]",
                                  key[0], key[1], key[2], key[3],
                                  key[4], key[5], key[6], key[7]));
        }
        else {
            auto pt = tf.decrypt(cast(ubyte[])std.file.read(infile));
            std.file.write(outfile, pt);
        }
    }
    else {
        writeln("please drag-and-drop target file");
        version (MakeIVInit) make_initIV();
    }
}

void make_initIV() {
    writeln("new init iv table");
    writef("INIT_IV_TABLE = [");
    Random gen = unpredictableSeed();
    for (int i=0; i<4; i++) {
        if (i!=0)
            writef(", ");
        writef("0x%08x",
               uniform(0, 0x10000, gen) << 16 | uniform(0, 0x10000, gen));
    }
    writef("]");
}


